
// -*- c++ -*-
/* Do not edit! -- generated file */

#ifndef DBUS_CXX_METHOD_H
#define DBUS_CXX_METHOD_H

#include <dbus-cxx/methodbase.h>
    
namespace DBus {


  /**
   * @ingroup local
   * @ingroup objects
   * 
   * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
   */
  template <class T_return, class T_arg1 = nil,class T_arg2 = nil,class T_arg3 = nil,class T_arg4 = nil,class T_arg5 = nil,class T_arg6 = nil,class T_arg7 = nil>
  class Method 
    : public MethodBase
  {
  public:

    typedef DBusCxxPointer<Method> pointer;

    Method(const std::string& name):
      MethodBase(name)
    {  }

    virtual HandlerResult handle_call_message( DBusCxxPointer<Connection> connection, CallMessage::const_pointer message )
    {
      DBUS_CXX_DEBUG("Method<T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5,T_arg6,T_arg7>::handle_call_message   method=" << m_name );
      
      if ( not connection or not message ) return NOT_HANDLED;

      T_return _retval;
            
      T_arg1 _val_1;
      T_arg2 _val_2;
      T_arg3 _val_3;
      T_arg4 _val_4;
      T_arg5 _val_5;
      T_arg6 _val_6;
      T_arg7 _val_7;

      
      try {
        Message::iterator i = message->begin();
        i  >> _val_1 >> _val_2 >> _val_3 >> _val_4 >> _val_5 >> _val_6 >> _val_7;
      }
      catch ( ErrorInvalidTypecast& e ) {
          return NOT_HANDLED;
      }
      

      _retval = m_slot(_val_1,_val_2,_val_3,_val_4,_val_5,_val_6,_val_7);

      ReturnMessage::pointer retmsg = message->create_reply();

      if ( not retmsg ) return NOT_HANDLED;

      retmsg << _retval;

      connection << retmsg;

      return HANDLED;
    }

    void set_method( sigc::slot7<T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5,T_arg6,T_arg7> slot )
    { m_slot = slot; }

    static pointer create(const std::string& name)
    { return pointer( new Method(name) ); }

    virtual MethodBase::pointer clone()
    { return MethodBase::pointer( new Method(this->name()) ); }

  protected:

    sigc::slot7<T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5,T_arg6,T_arg7> m_slot;

  };



  /**
   * @ingroup local
   * @ingroup objects
   * 
   * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
   */
  template <class T_return>
  class Method <T_return, nil,nil,nil,nil,nil,nil,nil>
    : public MethodBase
  {
  public:

    typedef DBusCxxPointer<Method> pointer;

    Method(const std::string& name):
      MethodBase(name)
    {  }

    virtual HandlerResult handle_call_message( DBusCxxPointer<Connection> connection, CallMessage::const_pointer message )
    {
      DBUS_CXX_DEBUG("Method<T_return>::handle_call_message   method=" << m_name );
      
      if ( not connection or not message ) return NOT_HANDLED;

      T_return _retval;
            

      

      _retval = m_slot();

      ReturnMessage::pointer retmsg = message->create_reply();

      if ( not retmsg ) return NOT_HANDLED;

      retmsg << _retval;

      connection << retmsg;

      return HANDLED;
    }

    void set_method( sigc::slot0<T_return> slot )
    { m_slot = slot; }

    static pointer create(const std::string& name)
    { return pointer( new Method(name) ); }

    virtual MethodBase::pointer clone()
    { return MethodBase::pointer( new Method(this->name()) ); }

  protected:

    sigc::slot0<T_return> m_slot;

  };


  /**
   * @ingroup local
   * @ingroup objects
   * 
   * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
   */
  template <class T_return, class T_arg1>
  class Method <T_return, T_arg1, nil,nil,nil,nil,nil,nil>
    : public MethodBase
  {
  public:

    typedef DBusCxxPointer<Method> pointer;

    Method(const std::string& name):
      MethodBase(name)
    {  }

    virtual HandlerResult handle_call_message( DBusCxxPointer<Connection> connection, CallMessage::const_pointer message )
    {
      DBUS_CXX_DEBUG("Method<T_return, T_arg1>::handle_call_message   method=" << m_name );
      
      if ( not connection or not message ) return NOT_HANDLED;

      T_return _retval;
            
      T_arg1 _val_1;

      
      try {
        Message::iterator i = message->begin();
        i  >> _val_1;
      }
      catch ( ErrorInvalidTypecast& e ) {
          return NOT_HANDLED;
      }
      

      _retval = m_slot(_val_1);

      ReturnMessage::pointer retmsg = message->create_reply();

      if ( not retmsg ) return NOT_HANDLED;

      retmsg << _retval;

      connection << retmsg;

      return HANDLED;
    }

    void set_method( sigc::slot1<T_return, T_arg1> slot )
    { m_slot = slot; }

    static pointer create(const std::string& name)
    { return pointer( new Method(name) ); }

    virtual MethodBase::pointer clone()
    { return MethodBase::pointer( new Method(this->name()) ); }

  protected:

    sigc::slot1<T_return, T_arg1> m_slot;

  };


  /**
   * @ingroup local
   * @ingroup objects
   * 
   * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
   */
  template <class T_return, class T_arg1,class T_arg2>
  class Method <T_return, T_arg1,T_arg2, nil,nil,nil,nil,nil>
    : public MethodBase
  {
  public:

    typedef DBusCxxPointer<Method> pointer;

    Method(const std::string& name):
      MethodBase(name)
    {  }

    virtual HandlerResult handle_call_message( DBusCxxPointer<Connection> connection, CallMessage::const_pointer message )
    {
      DBUS_CXX_DEBUG("Method<T_return, T_arg1,T_arg2>::handle_call_message   method=" << m_name );
      
      if ( not connection or not message ) return NOT_HANDLED;

      T_return _retval;
            
      T_arg1 _val_1;
      T_arg2 _val_2;

      
      try {
        Message::iterator i = message->begin();
        i  >> _val_1 >> _val_2;
      }
      catch ( ErrorInvalidTypecast& e ) {
          return NOT_HANDLED;
      }
      

      _retval = m_slot(_val_1,_val_2);

      ReturnMessage::pointer retmsg = message->create_reply();

      if ( not retmsg ) return NOT_HANDLED;

      retmsg << _retval;

      connection << retmsg;

      return HANDLED;
    }

    void set_method( sigc::slot2<T_return, T_arg1,T_arg2> slot )
    { m_slot = slot; }

    static pointer create(const std::string& name)
    { return pointer( new Method(name) ); }

    virtual MethodBase::pointer clone()
    { return MethodBase::pointer( new Method(this->name()) ); }

  protected:

    sigc::slot2<T_return, T_arg1,T_arg2> m_slot;

  };


  /**
   * @ingroup local
   * @ingroup objects
   * 
   * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
   */
  template <class T_return, class T_arg1,class T_arg2,class T_arg3>
  class Method <T_return, T_arg1,T_arg2,T_arg3, nil,nil,nil,nil>
    : public MethodBase
  {
  public:

    typedef DBusCxxPointer<Method> pointer;

    Method(const std::string& name):
      MethodBase(name)
    {  }

    virtual HandlerResult handle_call_message( DBusCxxPointer<Connection> connection, CallMessage::const_pointer message )
    {
      DBUS_CXX_DEBUG("Method<T_return, T_arg1,T_arg2,T_arg3>::handle_call_message   method=" << m_name );
      
      if ( not connection or not message ) return NOT_HANDLED;

      T_return _retval;
            
      T_arg1 _val_1;
      T_arg2 _val_2;
      T_arg3 _val_3;

      
      try {
        Message::iterator i = message->begin();
        i  >> _val_1 >> _val_2 >> _val_3;
      }
      catch ( ErrorInvalidTypecast& e ) {
          return NOT_HANDLED;
      }
      

      _retval = m_slot(_val_1,_val_2,_val_3);

      ReturnMessage::pointer retmsg = message->create_reply();

      if ( not retmsg ) return NOT_HANDLED;

      retmsg << _retval;

      connection << retmsg;

      return HANDLED;
    }

    void set_method( sigc::slot3<T_return, T_arg1,T_arg2,T_arg3> slot )
    { m_slot = slot; }

    static pointer create(const std::string& name)
    { return pointer( new Method(name) ); }

    virtual MethodBase::pointer clone()
    { return MethodBase::pointer( new Method(this->name()) ); }

  protected:

    sigc::slot3<T_return, T_arg1,T_arg2,T_arg3> m_slot;

  };


  /**
   * @ingroup local
   * @ingroup objects
   * 
   * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
   */
  template <class T_return, class T_arg1,class T_arg2,class T_arg3,class T_arg4>
  class Method <T_return, T_arg1,T_arg2,T_arg3,T_arg4, nil,nil,nil>
    : public MethodBase
  {
  public:

    typedef DBusCxxPointer<Method> pointer;

    Method(const std::string& name):
      MethodBase(name)
    {  }

    virtual HandlerResult handle_call_message( DBusCxxPointer<Connection> connection, CallMessage::const_pointer message )
    {
      DBUS_CXX_DEBUG("Method<T_return, T_arg1,T_arg2,T_arg3,T_arg4>::handle_call_message   method=" << m_name );
      
      if ( not connection or not message ) return NOT_HANDLED;

      T_return _retval;
            
      T_arg1 _val_1;
      T_arg2 _val_2;
      T_arg3 _val_3;
      T_arg4 _val_4;

      
      try {
        Message::iterator i = message->begin();
        i  >> _val_1 >> _val_2 >> _val_3 >> _val_4;
      }
      catch ( ErrorInvalidTypecast& e ) {
          return NOT_HANDLED;
      }
      

      _retval = m_slot(_val_1,_val_2,_val_3,_val_4);

      ReturnMessage::pointer retmsg = message->create_reply();

      if ( not retmsg ) return NOT_HANDLED;

      retmsg << _retval;

      connection << retmsg;

      return HANDLED;
    }

    void set_method( sigc::slot4<T_return, T_arg1,T_arg2,T_arg3,T_arg4> slot )
    { m_slot = slot; }

    static pointer create(const std::string& name)
    { return pointer( new Method(name) ); }

    virtual MethodBase::pointer clone()
    { return MethodBase::pointer( new Method(this->name()) ); }

  protected:

    sigc::slot4<T_return, T_arg1,T_arg2,T_arg3,T_arg4> m_slot;

  };


  /**
   * @ingroup local
   * @ingroup objects
   * 
   * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
   */
  template <class T_return, class T_arg1,class T_arg2,class T_arg3,class T_arg4,class T_arg5>
  class Method <T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5, nil,nil>
    : public MethodBase
  {
  public:

    typedef DBusCxxPointer<Method> pointer;

    Method(const std::string& name):
      MethodBase(name)
    {  }

    virtual HandlerResult handle_call_message( DBusCxxPointer<Connection> connection, CallMessage::const_pointer message )
    {
      DBUS_CXX_DEBUG("Method<T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5>::handle_call_message   method=" << m_name );
      
      if ( not connection or not message ) return NOT_HANDLED;

      T_return _retval;
            
      T_arg1 _val_1;
      T_arg2 _val_2;
      T_arg3 _val_3;
      T_arg4 _val_4;
      T_arg5 _val_5;

      
      try {
        Message::iterator i = message->begin();
        i  >> _val_1 >> _val_2 >> _val_3 >> _val_4 >> _val_5;
      }
      catch ( ErrorInvalidTypecast& e ) {
          return NOT_HANDLED;
      }
      

      _retval = m_slot(_val_1,_val_2,_val_3,_val_4,_val_5);

      ReturnMessage::pointer retmsg = message->create_reply();

      if ( not retmsg ) return NOT_HANDLED;

      retmsg << _retval;

      connection << retmsg;

      return HANDLED;
    }

    void set_method( sigc::slot5<T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5> slot )
    { m_slot = slot; }

    static pointer create(const std::string& name)
    { return pointer( new Method(name) ); }

    virtual MethodBase::pointer clone()
    { return MethodBase::pointer( new Method(this->name()) ); }

  protected:

    sigc::slot5<T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5> m_slot;

  };


  /**
   * @ingroup local
   * @ingroup objects
   * 
   * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
   */
  template <class T_return, class T_arg1,class T_arg2,class T_arg3,class T_arg4,class T_arg5,class T_arg6>
  class Method <T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5,T_arg6, nil>
    : public MethodBase
  {
  public:

    typedef DBusCxxPointer<Method> pointer;

    Method(const std::string& name):
      MethodBase(name)
    {  }

    virtual HandlerResult handle_call_message( DBusCxxPointer<Connection> connection, CallMessage::const_pointer message )
    {
      DBUS_CXX_DEBUG("Method<T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5,T_arg6>::handle_call_message   method=" << m_name );
      
      if ( not connection or not message ) return NOT_HANDLED;

      T_return _retval;
            
      T_arg1 _val_1;
      T_arg2 _val_2;
      T_arg3 _val_3;
      T_arg4 _val_4;
      T_arg5 _val_5;
      T_arg6 _val_6;

      
      try {
        Message::iterator i = message->begin();
        i  >> _val_1 >> _val_2 >> _val_3 >> _val_4 >> _val_5 >> _val_6;
      }
      catch ( ErrorInvalidTypecast& e ) {
          return NOT_HANDLED;
      }
      

      _retval = m_slot(_val_1,_val_2,_val_3,_val_4,_val_5,_val_6);

      ReturnMessage::pointer retmsg = message->create_reply();

      if ( not retmsg ) return NOT_HANDLED;

      retmsg << _retval;

      connection << retmsg;

      return HANDLED;
    }

    void set_method( sigc::slot6<T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5,T_arg6> slot )
    { m_slot = slot; }

    static pointer create(const std::string& name)
    { return pointer( new Method(name) ); }

    virtual MethodBase::pointer clone()
    { return MethodBase::pointer( new Method(this->name()) ); }

  protected:

    sigc::slot6<T_return, T_arg1,T_arg2,T_arg3,T_arg4,T_arg5,T_arg6> m_slot;

  };



} /* namespace DBus */

#endif /* DBUS_CXX_METHOD_H */

